package de.pschuett.dialogs;

import java.util.*;
import java.io.*;
import java.util.jar.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

/**
 *  Info dialog with version information
 *
 * @author    ps
 */
public class Infodialog extends JDialog implements ActionListener
{

    JPanel panel1 = new JPanel();
    JPanel panel2 = new JPanel();
    JPanel insetsPanel1 = new JPanel();
    JPanel insetsPanel2 = new JPanel();
    JPanel insetsPanel3 = new JPanel();
    JButton okButton = new JButton();
    JLabel titleLabel = new JLabel();
    JLabel versionLabel = new JLabel();
    JLabel copyrightLabel = new JLabel();
    JLabel commentLabel = new JLabel();
    String product = "Nicht verfgbar";
    String version = "Nicht verfgbar";
    String copyright = "Nicht verfgbar";
    String comments = "";
    BorderLayout borderLayout1 = new BorderLayout();
    BorderLayout borderLayout2 = new BorderLayout();
    BorderLayout borderLayout3 = new BorderLayout();
    JLabel jLabel1 = new JLabel();
    JLabel jLabel2 = new JLabel();
    JTabbedPane jTabbedPane1 = new JTabbedPane();
    JLabel imageLabel = new JLabel();
    JScrollPane jSystemScrollPane = new JScrollPane();
    JTextArea jSystemTextArea = new JTextArea();

    /**
     *  Default constructor
     *
     * @param  parent  parent window
     */
    public Infodialog(Frame parent)
    {
        super(parent);
        enableEvents(AWTEvent.WINDOW_EVENT_MASK);
        try
        {
            jbInit();
        }
        catch (Exception e)
        {
            e.printStackTrace();
        }
        pack();
    }


    /**
     *  Initializing of the gui elements
     */
    private void jbInit() throws Exception
    {
        this.setTitle("Info");
        this.getContentPane().setLayout(borderLayout3);
        setResizable(false);
        panel1.setLayout(borderLayout2);
        panel2.setLayout(borderLayout1);
        insetsPanel2.setLayout(null);
        insetsPanel2.setMinimumSize(new Dimension(110, 120));
        insetsPanel2.setPreferredSize(new Dimension(120, 120));
        titleLabel.setFont(new java.awt.Font("Serif", 3, 24));
        titleLabel.setHorizontalAlignment(SwingConstants.LEFT);
        titleLabel.setHorizontalTextPosition(SwingConstants.LEFT);
        titleLabel.setText(product);
        titleLabel.setVerticalAlignment(SwingConstants.TOP);
        titleLabel.setVerticalTextPosition(SwingConstants.TOP);
        titleLabel.setBounds(new Rectangle(4, 0, 223, 45));
        versionLabel.setText(version);
        versionLabel.setBounds(new Rectangle(4, 49, 130, 30));
        copyrightLabel.setText("nicht verfgbar");
        copyrightLabel.setBounds(new Rectangle(4, 74, 220, 37));
        commentLabel.setText(comments);
        commentLabel.setBounds(new Rectangle(4, 107, 220, 66));
        insetsPanel3.setLayout(null);
        insetsPanel3.setBorder(BorderFactory.createEmptyBorder(10, 60, 10, 10));
        insetsPanel3.setMinimumSize(new Dimension(200, 102));
        insetsPanel3.setPreferredSize(new Dimension(350, 300));
        okButton.setText("OK");
        okButton.addActionListener(this);
        panel1.setMinimumSize(new Dimension(300, 100));
        panel1.setPreferredSize(new Dimension(350, 210));
        panel2.setMinimumSize(new Dimension(240, 120));
        panel2.setPreferredSize(new Dimension(280, 200));
        jLabel1.setForeground(Color.blue);
        jLabel1.setText("www.pstt.de");
        jLabel1.setBounds(new Rectangle(3, 133, 99, 17));
        jLabel2.setForeground(Color.blue);
        jLabel2.setText("software@pstt.de");
        jLabel2.setBounds(new Rectangle(4, 152, 100, 17));
        jTabbedPane1.setTabPlacement(JTabbedPane.BOTTOM);
        jTabbedPane1.setFont(new java.awt.Font("Dialog", 0, 0));
        jTabbedPane1.setBounds(new Rectangle(0, 0, 115, 130));
        imageLabel.setMaximumSize(new Dimension(2147483647, 2147483647));
        imageLabel.setMinimumSize(new Dimension(96, 96));
        imageLabel.setPreferredSize(new Dimension(96, 96));
        jSystemTextArea.setText("");
        jSystemTextArea.setToolTipText("");
        jSystemTextArea.setFont(new java.awt.Font("Dialog", 0, 10));
        panel2.add(insetsPanel3, BorderLayout.CENTER);
        insetsPanel3.add(titleLabel, null);
        insetsPanel3.add(versionLabel, null);
        insetsPanel3.add(commentLabel, null);
        insetsPanel3.add(copyrightLabel, null);
        panel2.add(insetsPanel2, BorderLayout.WEST);
        insetsPanel2.add(jLabel2, null);
        insetsPanel2.add(jLabel1, null);
        insetsPanel2.add(jTabbedPane1, null);
        jTabbedPane1.add(imageLabel, "imageLabel");
        jTabbedPane1.add(jSystemScrollPane, "jScrollPane1");
        jSystemScrollPane.getViewport().add(jSystemTextArea, null);
        this.getContentPane().add(panel1, BorderLayout.CENTER);
        insetsPanel1.add(okButton, null);
        panel1.add(insetsPanel1, BorderLayout.SOUTH);
        panel1.add(panel2, BorderLayout.CENTER);
        // Version info
        Package pack = Package.getPackage("de.pschuett.dialogs");
        if  (pack.getImplementationTitle() == null)  // not in a jar
        {
            Manifest man = new Manifest(new FileInputStream(getClass().getResource("/META-INF/Manifest.mf").getFile()));
            titleLabel.setText(man.getMainAttributes().getValue("Implementation-Title"));
            versionLabel.setText(man.getMainAttributes().getValue("Implementation-Version"));
            copyrightLabel.setText(man.getMainAttributes().getValue("Implementation-Vendor"));
        }
        else  // in a jar
        {
            titleLabel.setText(pack.getImplementationTitle());
            versionLabel.setText(pack.getImplementationVersion());
            copyrightLabel.setText(pack.getImplementationVendor());
        }
        // System Properties
        Properties props = System.getProperties();
        Enumeration propNames = props.propertyNames();
        StringBuffer str = new StringBuffer();
        while (propNames.hasMoreElements())
        {
            String key = (String)propNames.nextElement();
            str.append(key);
            str.append(" = ");
            str.append(props.getProperty(key));
            str.append("\n");
        }
        jSystemTextArea.setText(str.toString());
    }


    /**
     *  Finish dialog
     */
    void cancel()
    {
        dispose();
    }


    /**
     *  Makes finishing of the window possible
     */
    protected void processWindowEvent(WindowEvent e)
    {
        if (e.getID() == WindowEvent.WINDOW_CLOSING)
        {
            cancel();
        }
        super.processWindowEvent(e);
    }


    /**
     *  Close dialog when pressing OK
     */
    public void actionPerformed(ActionEvent e)
    {
        if (e.getSource() == okButton)
        {
            cancel();
        }
    }

    /**
     * Sets the program logo
     */
    public void setLogo(Image logoImage)
    {
        imageLabel.setIcon(new ImageIcon(logoImage.getScaledInstance(120, 120, Image.SCALE_DEFAULT)));
    }
}
