package de.pschuett.editor;

import javax.swing.UIManager;
import java.awt.*;
import java.io.File;

/**
 *  Main class of Peters Multi-Editor
 *
 * @author     ps
 * @version    1.0
 */

public class EditorMain
{
    boolean packFrame = false;


    /**
     *  Construct the application
     *
     * @param  args  Commandline parameters to open a file directly after start
     */
    public EditorMain(String[] args)
    {
        EditorFrame frame = new EditorFrame();
        //Frames berprfen, die voreingestellte Gre haben
        //Frames packen, die nutzbare bevorzugte Greninformationen enthalten, z.B. aus ihrem Layout
        if (packFrame)
        {
            frame.pack();
        }
        else
        {
            frame.validate();
        }
        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
        Dimension frameSize = frame.getSize();
        if (frameSize.height > screenSize.height)
        {
            frameSize.height = screenSize.height;
        }
        if (frameSize.width > screenSize.width)
        {
            frameSize.width = screenSize.width;
        }
        for (int ii = 0; ii < args.length; ii++)
        {
            frame.openFile(new File(args[ii]));
        }
        frame.setVisible(true);
    }


    /**
     *  main method
     *
     * @param  args  The command line arguments
     */
    public static void main(String[] args)
    {
        try
        {
            UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
        }
        catch (Exception e)
        {
            e.printStackTrace();
        }
        new EditorMain(args);
    }
}
