package de.pschuett.editor;

import java.awt.print.Printable;
import java.awt.*;
import java.awt.print.*;
import javax.swing.JTextArea;

/**
 *  This class should handle the printing of <code>JTextArea</code> . <br>
 *  It is still not tested completely.
 *
 * @author     ps
 * @version    0.0 beta
 */

public class EditorPrintable implements Printable
{
    private JTextArea textArea;
    private boolean updated = false;
    private int linesPerPage;


    /**
     *  Default constructor which gets the JTextArea which has to be printed
     *
     * @param  aTextArea  The JTextArea which has to be printed
     */
    public EditorPrintable(JTextArea aTextArea)
    {
        textArea = aTextArea;
    }


    /**
     *  Update method (still not used)
     */
    public void update()
    {
        updated = false;
    }


    /**
     *  Print method<br>
     *  It has still the bug that lines at the end of a page could be printed
     *  over to pages.
     */
    public int print(Graphics graphics, PageFormat pageFormat, int pageIndex)
    {
        //throws PrinterException

        /*
         * if (!updated)
         * {
         * int lineHeight = textArea.getFont().getSize2D() ;
         * textArea.getFontMetrics(textArea.getFont()). ;
         * linesPerPage = new Integer(pageFormat.getImageableHeight()/lineHeight).intValue();
         * }
         * int lineCount = textArea.getLineCount();
         * if (pageIndex * linesPerPage > lineCount)
         * return Printable.NO_SUCH_PAGE;
         * String line;
         * for (int ii=linesPerPage*PageIndex; (ii<linesPerPage*(PageIndex+1)) && (ii<lineCount); ii++)
         * {
         * textArea.getDocument().
         * graphics.drawString(line, 0, ii*lineHeight);
         * }
         * return Printable.PAGE_EXISTS;
         */

        Dimension d = textArea.getSize();
        double panelWidth = d.width;
        double panelHeight = d.height;

        double pageHeight = pageFormat.getImageableHeight();
        double pageWidth = pageFormat.getImageableWidth();

        double scale = pageWidth / panelWidth;
        int totalNumPages = (int)Math.ceil(scale * panelHeight / pageHeight);

        if (pageIndex >= totalNumPages)
        {
            return Printable.NO_SUCH_PAGE;
        }

        Graphics2D g2 = (Graphics2D)graphics;
        g2.translate(pageFormat.getImageableX(), pageFormat.getImageableY());
        g2.translate(0f, -pageIndex * pageHeight);
        g2.scale(scale, scale);

        Color color = textArea.getCaretColor();
        textArea.setCaretColor(Color.white);
        textArea.paint(g2);
        textArea.setCaretColor(color);

        return Printable.PAGE_EXISTS;
    }
}
