package de.pschuett.find;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

/**
 *  search and replace dialog
 *
 * @author     ps
 * @version    1.0
 */
public class FindDialog extends JDialog
{
    JPanel contentPanel = new JPanel();
    GridBagLayout gridBagLayout1 = new GridBagLayout();
    GridBagLayout gridBagLayout2 = new GridBagLayout();
    JPanel jReplacePanel = new JPanel();
    JPanel jFindPanel = new JPanel();
    JPanel jButtonPanel = new JPanel();
    JTextArea jFindText = new JTextArea();
    GridBagLayout gridBagLayout3 = new GridBagLayout();
    GridBagLayout gridBagLayout4 = new GridBagLayout();
    GridBagLayout gridBagLayout5 = new GridBagLayout();
    JPanel jOptionsPanel = new JPanel();
    JCheckBox jCaseSensitiveCheckBox = new JCheckBox();
    GridBagLayout gridBagLayout6 = new GridBagLayout();
    JCheckBox jWholeWordCheckBox = new JCheckBox();
    JCheckBox jAllCheckBox = new JCheckBox();
    JLabel jLabel1 = new JLabel();
    JLabel jLabel2 = new JLabel();
    JTextArea jReplaceText = new JTextArea();
    JButton jFindNextButton = new JButton();
    JButton jReplaceButton = new JButton();
    JButton jReplaceAllButton = new JButton();
    JButton jCancelButton = new JButton();
    JRadioButton jDownButton = new JRadioButton();
    JRadioButton jUpButton = new JRadioButton();
    ButtonGroup directionButtonGroup = new ButtonGroup();
    FindOptions mFindOptions;
    JCheckBox jFromBeginningCheckBox = new JCheckBox();


    /**
     *  Default constructor
     *
     * @param  parent  parent window
     */
    public FindDialog(Frame parent)
    {
        super(parent);
        enableEvents(AWTEvent.WINDOW_EVENT_MASK);
        try
        {
            jbInit();
            pack();
        }
        catch (Exception ex)
        {
            ex.printStackTrace();
        }
    }


    /**
     *  updates FindOptions object by the GUI elements
     */
    private void updateFindOptions()
    {
        mFindOptions.setBackwards(jUpButton.isSelected());
        mFindOptions.setSearchText(jFindText.getText());
        mFindOptions.setReplaceText(jReplaceText.getText());
        mFindOptions.setWholeWord(jWholeWordCheckBox.isSelected());
        mFindOptions.setSearchAllFiles(jAllCheckBox.isSelected());
        mFindOptions.setCaseSensitive(jCaseSensitiveCheckBox.isSelected());
        mFindOptions.setSearchFromStart(jFromBeginningCheckBox.isSelected());
    }


    /**
     *  Initialization of the gui elements
     */
    void jbInit() throws Exception
    {
        contentPanel.setLayout(gridBagLayout2);
        this.getContentPane().setLayout(gridBagLayout1);
        jFindPanel.setPreferredSize(new Dimension(200, 100));
        jFindPanel.setLayout(gridBagLayout3);
        jReplacePanel.setPreferredSize(new Dimension(200, 100));
        jReplacePanel.setLayout(gridBagLayout4);
        jButtonPanel.setMaximumSize(new Dimension(170, 2147483647));
        jButtonPanel.setMinimumSize(new Dimension(170, 153));
        jButtonPanel.setPreferredSize(new Dimension(170, 200));
        jButtonPanel.setLayout(gridBagLayout5);
        jCaseSensitiveCheckBox.setText("Gro-/Kleinschreibung");
        jOptionsPanel.setLayout(gridBagLayout6);
        jWholeWordCheckBox.setText("Nur ganzes Wort");
        jAllCheckBox.setText("Alle Dateien");
        jLabel1.setText("Suchen nach:");
        jLabel2.setText("Ersetzen durch:");
        jFindNextButton.setMaximumSize(new Dimension(541, 27));
        jFindNextButton.setMinimumSize(new Dimension(141, 27));
        jFindNextButton.setPreferredSize(new Dimension(170, 27));
        jFindNextButton.setText("Weitersuchen");
        jFindNextButton.setMnemonic('0');
        jFindNextButton.addActionListener(
            new java.awt.event.ActionListener()
            {
                /**
                 * {@link FindDialog#jFindNextButton_actionPerformed}
                 */
                public void actionPerformed(ActionEvent e)
                {
                    jFindNextButton_actionPerformed(e);
                }
            });
        jReplaceButton.setMaximumSize(new Dimension(541, 27));
        jReplaceButton.setMinimumSize(new Dimension(141, 27));
        jReplaceButton.setPreferredSize(new Dimension(170, 27));
        jReplaceButton.setText("Ersetzen");
        jReplaceButton.setMnemonic('0');
        jReplaceButton.addActionListener(
            new java.awt.event.ActionListener()
            {
                /**
                 * {@link FindDialog#jReplaceButton_actionPerformed}
                 */
                public void actionPerformed(ActionEvent e)
                {
                    jReplaceButton_actionPerformed(e);
                }
            });
        jReplaceAllButton.setMaximumSize(new Dimension(541, 27));
        jReplaceAllButton.setMinimumSize(new Dimension(141, 27));
        jReplaceAllButton.setPreferredSize(new Dimension(170, 27));
        jReplaceAllButton.setText("Alles Ersetzen");
        jReplaceAllButton.setMnemonic('0');
        jReplaceAllButton.addActionListener(
            new java.awt.event.ActionListener()
            {
                /**
                 * {@link FindDialog#jReplaceAllButton_actionPerformed}
                 */
                public void actionPerformed(ActionEvent e)
                {
                    jReplaceAllButton_actionPerformed(e);
                }
            });
        jCancelButton.setMaximumSize(new Dimension(541, 27));
        jCancelButton.setMinimumSize(new Dimension(141, 27));
        jCancelButton.setPreferredSize(new Dimension(170, 27));
        jCancelButton.setText("Abbrechen");
        jCancelButton.setMnemonic('0');
        jCancelButton.addActionListener(
            new java.awt.event.ActionListener()
            {
                /**
                 * {@link FindDialog#jCancelButton_actionPerformed}
                 */
                public void actionPerformed(ActionEvent e)
                {
                    jCancelButton_actionPerformed(e);
                }
            });
        jDownButton.setSelected(true);
        jDownButton.setText("Vorwrts");
        jUpButton.setText("Rckwrts");
        jFromBeginningCheckBox.setText("Von Anfang");
        getContentPane().add(contentPanel, new GridBagConstraints(0, 0, 2, 1, 100.0, 100.0
                , GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(0, 0, 0, 0), 0, 0));
        contentPanel.add(jFindPanel, new GridBagConstraints(0, 0, 1, 1, 100.0, 100.0
                , GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(0, 0, 0, 0), 0, 0));
        jFindPanel.add(jFindText, new GridBagConstraints(0, 1, 1, 1, 100.0, 100.0
                , GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(0, 0, 0, 0), 0, 0));
        jFindPanel.add(jLabel1, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
                , GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
        contentPanel.add(jReplacePanel, new GridBagConstraints(0, 1, 1, 1, 100.0, 100.0
                , GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(0, 0, 0, 0), 0, 0));
        jReplacePanel.add(jLabel2, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
                , GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
        jReplacePanel.add(jReplaceText, new GridBagConstraints(0, 1, 1, 1, 100.0, 100.0
                , GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(0, 0, 0, 0), 0, 0));
        contentPanel.add(jButtonPanel, new GridBagConstraints(1, 0, 1, 3, 0.0, 100.0
                , GridBagConstraints.CENTER, GridBagConstraints.VERTICAL, new Insets(0, 0, 0, 0), -19, 0));
        jButtonPanel.add(jFindNextButton, new GridBagConstraints(0, 0, 1, 1, 100.0, 0.0
                , GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(10, 10, 5, 10), 0, 0));
        jButtonPanel.add(jReplaceButton, new GridBagConstraints(0, 1, 1, 1, 100.0, 0.0
                , GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(5, 10, 5, 10), 0, 0));
        jButtonPanel.add(jReplaceAllButton, new GridBagConstraints(0, 2, 1, 1, 100.0, 0.0
                , GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(5, 10, 5, 10), 0, 0));
        jButtonPanel.add(jCancelButton, new GridBagConstraints(0, 3, 1, 1, 100.0, 10.0
                , GridBagConstraints.NORTH, GridBagConstraints.HORIZONTAL, new Insets(5, 10, 5, 10), 0, 0));
        contentPanel.add(jOptionsPanel, new GridBagConstraints(0, 2, 1, 1, 100.0, 0.0
                , GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 0), 0, 0));
        jOptionsPanel.add(jCaseSensitiveCheckBox, new GridBagConstraints(0, 1, 1, 1, 100.0, 0.0
                , GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 0), 0, 0));
        jOptionsPanel.add(jWholeWordCheckBox, new GridBagConstraints(0, 0, 1, 1, 100.0, 0.0
                , GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 0), 0, 0));
        jOptionsPanel.add(jAllCheckBox, new GridBagConstraints(0, 2, 1, 1, 100.0, 0.0
                , GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 0), 0, 0));
        jOptionsPanel.add(jDownButton, new GridBagConstraints(1, 0, 1, 1, 0.0, 0.0
                , GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
        jOptionsPanel.add(jUpButton, new GridBagConstraints(1, 1, 1, 1, 0.0, 0.0
                , GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
        jOptionsPanel.add(jFromBeginningCheckBox, new GridBagConstraints(0, 3, 1, 1, 100.0, 0.0
                , GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 0), 0, 0));
        directionButtonGroup.add(jDownButton);
        directionButtonGroup.add(jUpButton);
    }

    /**
     * Check if search string is empty
     */
    private boolean isSearchStringEmpty()
    {
        boolean result = (jFindText.getText().length() == 0);
        if (result)
            JOptionPane.showMessageDialog(this, "Es mu ein Suchtext eingegeben werden.");
        return result;
    }

    /**
     *  Applies the settings of this dialog and begins to search
     */
    void jFindNextButton_actionPerformed(ActionEvent e)
    {
        if (isSearchStringEmpty()) return;
        updateFindOptions();
        if (!mFindOptions.findNext())
        {
            JOptionPane.showMessageDialog(this, "'" + mFindOptions.getSearchText() + "' konnte nicht gefunden werden.");
        }
    }


    /**
     *  Applies the settings of this dialog and begins to search and replace
     */
    void jReplaceButton_actionPerformed(ActionEvent e)
    {
        if (isSearchStringEmpty()) return;
        updateFindOptions();
        if (!mFindOptions.replaceNext())
        {
            JOptionPane.showMessageDialog(this, "'" + mFindOptions.getSearchText() + "' konnte nicht gefunden werden.");
        }
    }


    /**
     *  Applies the settings of this dialog and replaces all search texts
     */
    void jReplaceAllButton_actionPerformed(ActionEvent e)
    {
        if (isSearchStringEmpty()) return;
        updateFindOptions();
        mFindOptions.replaceAll();
    }


    /**
     *  Finished the dialog
     */
    void jCancelButton_actionPerformed(ActionEvent e)
    {
        dispose();
    }


    /**
     *  updates GUI elements by the FindOptions object
     *
     * @param  aFindOptions  The new find options
     */
    public void setFindOptions(FindOptions aFindOptions)
    {
        mFindOptions = aFindOptions;
        jUpButton.setSelected(mFindOptions.isBackwards());
        jFindText.setText(mFindOptions.getSearchText());
        jReplaceText.setText(mFindOptions.getReplaceText());
        jWholeWordCheckBox.setSelected(mFindOptions.isWholeWord());
        jAllCheckBox.setSelected(mFindOptions.isSearchAllFiles());
        jCaseSensitiveCheckBox.setSelected(mFindOptions.isCaseSensitive());
        jFromBeginningCheckBox.setSelected(mFindOptions.isSearchFromStart());
    }
}
