package de.pschuett.find;

import java.util.*;

/**
 * search class for texts
 *
 * @author 	ps
 */
public class FindText
{
    private static Collection noLetters = null;

    /**
     * Search for the next position of the search text
     *
     * @return	true if found
     */
    public static int findNext(String srcText, int startPos, FindOptions opt)
    {
        // Initializing of no letters
        if (noLetters == null)
        {
            noLetters = new HashSet();
            noLetters.add(" ");
            noLetters.add("\n");
            noLetters.add("\t");
        }
        // searching
        String searchText;
        int result;
        if (!opt.isCaseSensitive())
        {
            srcText = srcText.toUpperCase();
            searchText = opt.getSearchText().toUpperCase();
        }
        else
            searchText = opt.getSearchText();
        boolean again;
        do
        {
            if (opt.isBackwards())
                result = srcText.lastIndexOf(searchText, startPos);
            else
                result = srcText.indexOf(searchText, startPos);
            if ((result >= 0) && opt.isWholeWord())
            {
                // checks if an empty char exists before word
                again = !((result == 0) || (noLetters.contains(srcText.substring(result-1, result))));
                if (!again)
                {
                    int afterPos = result + searchText.length();
                    // checks if an empty char exists after word
                    again = !((afterPos >= srcText.length()) || (noLetters.contains(srcText.substring(afterPos, afterPos+1))));
                }
                if (opt.isBackwards())
                    startPos = result-1;
                else
                    startPos = result + searchText.length();
            }
            else
                again = false ;
        } while(again);
        return result;
    }
}


